=== modified file 'bzrlib/tests/test_remote.py'
--- bzrlib/tests/test_remote.py	2007-04-30 02:04:06 +0000
+++ bzrlib/tests/test_remote.py	2007-04-30 06:42:24 +0000
@@ -422,6 +422,20 @@
             [('call', 'Transport.is_readonly', ())],
             client._calls)
 
+    def test_error_from_old_0_11_server(self):
+        """Same as test_error_from_old_server, but with the slightly different
+        error message from bzr 0.11 servers.
+        """
+        client = FakeClient([(
+            ('error', "Generic bzr smart protocol error: "
+                      "bad request u'Transport.is_readonly'"), '')])
+        transport = RemoteTransport('bzr://example.com/', medium=False,
+                                    _client=client)
+        self.assertEqual(False, transport.is_readonly())
+        self.assertEqual(
+            [('call', 'Transport.is_readonly', ())],
+            client._calls)
+
 
 class TestRemoteRepository(tests.TestCase):
     """Base for testing RemoteRepository protocol usage.

=== modified file 'bzrlib/transport/remote.py'
--- bzrlib/transport/remote.py	2007-04-30 04:00:06 +0000
+++ bzrlib/transport/remote.py	2007-04-30 06:42:24 +0000
@@ -133,8 +133,10 @@
             return True
         elif resp == ('no', ):
             return False
-        elif resp == ('error', "Generic bzr smart protocol error: "
-                               "bad request 'Transport.is_readonly'"):
+        elif (resp == ('error', "Generic bzr smart protocol error: "
+                                "bad request 'Transport.is_readonly'") or
+              resp == ('error', "Generic bzr smart protocol error: "
+                                "bad request u'Transport.is_readonly'")):
             # XXX: nasty hack: servers before 0.16 don't have a
             # 'Transport.is_readonly' verb, so we do what clients before 0.16
             # did: assume False.

